from java.util import Random
from jhplot  import *
from jhplot.io import *

input=PND('Data')
out=PND('Output')
r= Random()
for i in range(2000):
    mass=r.nextDouble()
    acceler=r.nextDouble()
    force=mass*acceler
    input.add([mass,acceler])
    out.add([force])
d={'input':input,'out':out}

# scale output
input=d['input']
out=d["out"]
input.standardize()
scale=out.rescale(0)

input=d['input'].getRows('input',0,1000)
out=d['out'].getRows('result',0,1000)


net = HNeuralNet()
net.addFeedForwardLayer(2)
net.addFeedForwardLayer(1)
net.reset()


net.setData(input, out)
print net.trainBackpropagation(1,2000,0.01,0.02,0.005)
print "Epoch error=",net.getEpochError()
net.save("test.eg","trainedNN","My trained NN")
net.showNetwork()

min,max =1000,2000
input=d['input'].getRows('input',min,max)
out=d["out"].getRows('result',min,max)


net=HNeuralNet()
net.read('test.eg','trainedNN');

pred=net.predict(input)
pred.rescale(scale)
out.rescale(scale)

d={'predicted':pred,'expected':out}
predicted=d['predicted']
expected=d['expected']
ratio=predicted.copy('ratio')
ratio.oper(expected,'/')

c1=HPlot()
c1.visible()
c1.setRange(0,2,0,100)

h=H1D('ratio',200,0,2.)
h.fill(ratio)
c1.draw(h)
c1.drawStatBox(h)

for i in range(1000): # check first 100 
   p=predicted.getRow(i)
   x=expected.getRow(i)
   d1=p.get(0)
   d2=x.get(0)
   print 'predicted=',d1,' expected=',d2


